#include <tchar.h>
#include <windows.h>
#include <atlstr.h>
#include <shlobj.h>
#include "resource.h"

HKEY CreateKey(LPCTSTR lpKey)
{
	HKEY hKey;
	DWORD dwDisp;
	RegCreateKeyEx(HKEY_LOCAL_MACHINE, lpKey, 0, NULL,
		REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL, &hKey, &dwDisp);
	return hKey;
}

void SetValue(HKEY hKey, LPCTSTR lpName, LPCTSTR lpValue)
{
	CString strValue(lpValue);
	if (lpName)
	{
		RegSetValueEx(hKey, lpName, 0, REG_SZ, (LPBYTE)(LPCTSTR)strValue,
			strValue.GetLength() * sizeof(TCHAR));
	}
	else
	{
		RegSetValue(hKey, NULL, REG_SZ, strValue, strValue.GetLength());
	}
}

void SaveResourceFile(LPCTSTR lpType, DWORD dwResId, LPCTSTR lpFileName)
{
	DWORD dwRet;
	HRSRC hResInfo = FindResource(NULL, MAKEINTRESOURCE(dwResId), lpType);
	HGLOBAL hResMem = LoadResource(NULL, hResInfo);
	DWORD dwSize = SizeofResource(NULL, hResInfo);
	LPVOID lpData = LockResource(hResMem);
	HANDLE hDllFile = CreateFile(lpFileName, GENERIC_WRITE, 0, NULL,
		CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	WriteFile(hDllFile, lpData, dwSize, &dwRet, NULL);
	CloseHandle(hDllFile);
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
				   LPSTR lpCmdLine, int nCmdShow)
{
	CString strRoot, strSubPath, strFile;
	SHGetFolderPath(NULL, CSIDL_PROGRAM_FILES_COMMON,
		NULL, SHGFP_TYPE_CURRENT, strRoot.GetBuffer(MAX_PATH));
	strRoot.ReleaseBuffer();
	strRoot += _T("\\Tencent\\");
	CreateDirectory(strRoot, NULL);
	strRoot += _T("TXSSO\\");
	CreateDirectory(strRoot, NULL);
	strRoot += _T("1.2.1.38\\");
	CreateDirectory(strRoot, NULL);
	strRoot += _T("Bin\\");
	CreateDirectory(strRoot, NULL);


	SaveResourceFile(_T("DLLFILE"), IDR_DLL_SSOCOMMON,
		strRoot + _T("SSOCommon.dll"));
	SaveResourceFile(_T("DLLFILE"), IDR_DLL_SSOPLATFORM,
		strRoot + _T("SSOPlatform.dll"));

	HKEY hKey;

	hKey = CreateKey(_T("SOFTWARE\\TENCENT\\TXSSO"));
	SetValue(hKey, _T("Version"), _T("1.2.1.38"));
	RegCloseKey(hKey);

	hKey = CreateKey(_T("SOFTWARE\\Classes\\SSOAxCtrlForPTLogin.SSOForPTLogin2"));
	SetValue(hKey, NULL, _T("SSOForPTLogin2 Class"));
	RegCloseKey(hKey);

	hKey = CreateKey(_T("SOFTWARE\\Classes\\SSOAxCtrlForPTLogin.SSOForPTLogin2\\CLSID"));
	SetValue(hKey, NULL, _T("{EAAED308-7322-4b9b-965E-171933ADD473}"));
	RegCloseKey(hKey);

	hKey = CreateKey(_T("SOFTWARE\\Classes\\SSOAxCtrlForPTLogin.SSOForPTLogin2\\CurVer"));
	SetValue(hKey, NULL, _T("SSOAxCtrlForPTLogin.SSOForPTLogin.2"));
	RegCloseKey(hKey);

	ShellExecute(NULL, _T("open"), _T("QQ.exe"), NULL, NULL, SW_SHOW);

	return 0;
}